﻿//DESCRIPTION: Add vertical paragraph rules to selected paragraphs
// Peter Kahrel -- www.kahrel.plus.com

// MODIFIER PAR : Baptiste Régné - www.nuagegraphik.fr -
// AJOUT : Permet d'encadrer le contenu - Boite de dialogue avec choix du style d'objet, possibilité de supprimer les cadres verrouillés: et choix de largeur
var valeur_espace = 4;
app.menuActions.itemByID(13313).invoke();

try {if (app.selection.length > 0)
    myDisplayDialog();
    app.menuActions.itemByID(13313).invoke();
}
catch (e) {alert (e.message)};


function myDisplayDialog(){
	var os;
	var largeur;
	var decal = 6; // decalage suivant le style
	var myDialog = app.dialogs.add({name:"Encadrer", canCancel:true});
	// création du style cadre neutre si il n'existe pas
	if (app.documents[0].objectStyles.item ("Style_neutre") == null)
    {
        var os = app.documents[0].objectStyles.add ({name: "Style_neutre"});
        os.basedOn = app.documents[0].objectStyles[0];
        os.strokeWeight = "0.5 pt";
        //coloration du fond en blanc
        assign_fillColor(os)
        function assign_fillColor(obj){ 
	obj.fillColor = document.colors.itemByName("Paper"); 
    };
        //application du mode "Multiply"///////////////////////
set_multiProp(os);
function set_multiProp(scope){
    var properties = ({blendingSettings:{blendMode:2020625762, opacity:100, knockoutGroup:false, isolateBlending:false, propertySetter:true}, dropShadowSettings:{distance:9.89949493661167, angle:135, mode:1852796517, blendMode:2020625762, opacity:75, xOffset:7, yOffset:7, size:5, effectColor:null, noise:0, spread:0, useGlobalLight:false, knockedOut:true, honorOtherEffects:false, propertySetter:true}, featherSettings:{mode:1852796517, width:9, cornerType:2020623203, noise:0, chokeAmount:0, propertySetter:true}, innerShadowSettings:{xOffset:3.5, yOffset:6.06217782649107, applied:false, effectColor:null, blendMode:2020625762, opacity:75, angle:120, distance:7, useGlobalLight:false, chokeAmount:0, size:7, noise:0, propertySetter:true}, outerGlowSettings:{applied:false, blendMode:2020625763, opacity:75, noise:0, effectColor:null, technique:2020618337, spread:0, size:7, propertySetter:true}, innerGlowSettings:{applied:false, blendMode:2020625763, opacity:75, noise:0, effectColor:null, technique:2020618337, spread:0, size:7, source:2020618594, propertySetter:true}, bevelAndEmbossSettings:{applied:false, style:2020618850, technique:2020619105, depth:100, direction:1181971566, size:7, soften:0, angle:120, altitude:30, useGlobalLight:false, highlightColor:null, highlightBlendMode:2020625763, highlightOpacity:75, shadowColor:null, shadowBlendMode:2020625762, shadowOpacity:75, propertySetter:true}, satinSettings:{applied:false, effectColor:null, blendMode:2020625762, opacity:50, angle:120, distance:7, size:7, invertEffect:false, propertySetter:true}, directionalFeatherSettings:{applied:false, leftWidth:0, rightWidth:0, topWidth:0, bottomWidth:0, chokeAmount:0, angle:0, followShapeMode:1701721441, noise:0, propertySetter:true}, gradientFeatherSettings:{applied:false, type:1635282023, angle:0, length:0, gradientStart:[0, 0], hiliteAngle:0, hiliteLength:0, propertySetter:true}, propertySetter:true});
    function setPropsIn(scope, props){
        for(var key in props){
             if(key == 'propertySetter') continue; 
            var value = props[key];
            try{
                if(value instanceof Object && 'propertySetter' in value){
                    setPropsIn(scope[key], value);
                }else{
                    scope[key] = value;
                }
            }catch(err){
		//Add Error handling code here.
			}
               
        }
    }
    setPropsIn(scope.fillTransparencySettings, properties)
}
        //fin application du mode "Multiply"///////////////////////
        //
        os.enableAnchoredObjectOptions = true;
        with (os.anchoredObjectSettings)
         {
			 spineRelative = false;
			 anchoredPosition = AnchorPosition.anchored;
			 anchorPoint = AnchorPoint.topLeftAnchor;
			 anchorXoffset = "3 mm";
			 verticalReferencePoint = AnchoredRelativeTo.columnEdge;
			 anchorYoffset = "-3 mm";
			 horizontalAlignment = HorizontalAlignment.leftAlign;
			 verticalReferencePoint = VerticallyRelativeTo.lineAscent;
			 pinPosition = false;
			 lockPosition = true;
		 }
    }
	//
	var mySwatchNames = app.activeDocument.objectStyles.everyItem().name;
	var style = app.selection[0].paragraphs[0].appliedParagraphStyle.name;
	//
	for(t=0;t<mySwatchNames.length;t++) if(mySwatchNames[t] == "Style_neutre") { position = t; break; };
	// trouver le positionnement du style ou neutre s'il n'est pas définit
	for(t=0;t<mySwatchNames.length;t++) if(mySwatchNames[t] == style) { position = t; break; };
	// trouver la largeur du texte
	frame_bounds = app.selection[0].parentTextFrames[0].geometricBounds;
	paragraph_width = frame_bounds[3] - frame_bounds[1] + decal;
	// création du style si il n'existe pas
	with(myDialog.dialogColumns.add()){
		with(dialogRows.add()){
			with(dialogColumns.add()){
				staticTexts.add({staticLabel:"Style :"});
			}
			var mySwatchDropdown = dropdowns.add({stringList:mySwatchNames,selectedIndex:position});
		}
	}
//
with(myDialog.dialogColumns.add()){
		with(dialogRows.add()){
			var myRangeButtons = radiobuttonGroups.add();
			with(myRangeButtons){
                //Fr
                radiobuttonControls.add({staticLabel:"Cadre autour du paragraphe", checkedState:true});
                radiobuttonControls.add({staticLabel:"Ligne verticale dans la marge"});
                //fin Fr
                /*/En
                radiobuttonControls.add({staticLabel:"Frame around paragraph", checkedState:true});
                radiobuttonControls.add({staticLabel:"Vertical line in margin"});
                *///end En
			}			
		}
	}
	var myResult = myDialog.show();
	if(myResult == true){
		switch(myRangeButtons.selectedButton){
			case 0:
				os = mySwatchNames[mySwatchDropdown.selectedIndex];
				largeur = paragraph_width/25.4*72;//myPointSizeField.editValue;
				myDialog.destroy();
				encadrer(os,largeur);
                 app.menuActions.itemByID(118785).invoke();
				break;
			case 1:
				os = mySwatchNames[mySwatchDropdown.selectedIndex];
				myDialog.destroy();
				creerbord(os);
                 app.menuActions.itemByID(118785).invoke();
				break;
		}		
	}
	else{
		myDialog.destroy();

	}
}

function encadrer (styleChoisi,lalargeur)
    {
    var vr, rule_length;
    var sel = app.selection[0];
    var p_first = sel.paragraphs[0];
	var largP = p_first.endHorizontalOffset;
    var p_last = sel.paragraphs[-1];
    var ascender = p_first.characters[0].ascent;
    var descender = p_first.characters[0].descent;
    var decalage = 4.5; // decalage suivant le style
	var largeur = lalargeur/72*25.4;
    var os = vrule_style (styleChoisi);
    // delete any vertical rules
    delete_rule (p_first, os);
    // add a rule at the first selected paragraph. We'll set its length later
    vr = p_first.insertionPoints[0].rectangles.add ({appliedObjectStyle: os});
	vr.locked=false; // débloque l'ojet pour le repositionner
	// Two possibilities
    // 1. Everything on the same page: set the par. rule of just the first paragraph 
    // from its first line to the last paragraph's last line
    if (p_first.lines[0].parentTextFrames[0] == p_last.lines[-1].parentTextFrames[0])
        {
        rule_length = p_last.lines[-1].baseline - p_first.lines[0].baseline + descender + ascender + decalage;
		vr.locked=false; // débloque l'ojet pour le repositionner
        vr.geometricBounds = [0, 0, rule_length, largeur];
        }
    else
        // 2. The last paragraph ends on another page: insert a rule in the first line of last selected paragraph's frame
        // and extend it to the last line of the selected paragraph.
        {
        // First set the rule at the first selected paragraph to extend to the bottom of its frame
        rule_length = p_first.parentTextFrames[0].lines[-1].baseline - p_first.lines[0].baseline + ascender + descender + decalage;
		vr.locked=false; // débloque l'ojet pour le repositionner
        vr.geometricBounds = [0, 0, rule_length, largeur];
		vr.locked=true; // débloque l'ojet pour le repositionner
        // Then try to delete any v. rules in the first paragraph of the second frame
        var first_line = p_last.lines[-1].parentTextFrames[0].lines[0];
        delete_rule (first_line.paragraphs[0], os);
        // Now add a rule at the first line of the next frame and extend it to the last line of the last selected paragraph
        rule_length = p_last.lines[-1].baseline - first_line.baseline + ascender + descender + decalage;
        vr = first_line.words[4].insertionPoints[-1].rectangles.add ();
        vr.appliedObjectStyle = os;
		vr.locked=false; // débloque l'ojet pour le repositionner
        vr.geometricBounds = [0, 0, rule_length, largeur];
		vr.locked=true; // débloque l'ojet pour le repositionner
        }
	vr.locked=true; // rebloque l'ojet pour le empécher le redimensionnement
       avant_apres(valeur_espace); //ajoute l'espace avant-après le paragraphe.

    }

function creerbord(styleChoisi) 
	{
	var vr, rule_length;
    var sel = app.selection[0];
    var p_first = sel.paragraphs[0];
	var largP = p_first.endHorizontalOffset;
    var p_last = sel.paragraphs[-1];
    var ascender = p_first.characters[0].ascent;
    var descender = p_first.characters[0].descent;
    var decalage = 4.5; // decalage suivant le style
	var largeur = 0;
    var os = vrule_style (styleChoisi);
    // delete any vertical rules
    delete_rule (p_first, os);
    // add a rule at the first selected paragraph. We'll set its length later
    vr = p_first.insertionPoints[0].graphicLines.add ({appliedObjectStyle: os});
	vr.locked=false; // débloque l'ojet pour le repositionner
	// Two possibilities
    // 1. Everything on the same page: set the par. rule of just the first paragraph 
    // from its first line to the last paragraph's last line
    if (p_first.lines[0].parentTextFrames[0] == p_last.lines[-1].parentTextFrames[0])
        {
        rule_length = p_last.lines[-1].baseline - p_first.lines[0].baseline + descender + ascender + decalage;
		vr.locked=false; // débloque l'ojet pour le repositionner
        vr.geometricBounds = [0, 0, rule_length, largeur];
        }
    else
        // 2. The last paragraph ends on another page: insert a rule in the first line of last selected paragraph's frame
        // and extend it to the last line of the selected paragraph.
        {
        // First set the rule at the first selected paragraph to extend to the bottom of its frame
        rule_length = p_first.parentTextFrames[0].lines[-1].baseline - p_first.lines[0].baseline + ascender + descender + decalage;
		vr.locked=false; // débloque l'ojet pour le repositionner
        vr.geometricBounds = [0, 0, rule_length, largeur];
		vr.locked=true; // débloque l'ojet pour le repositionner
        // Then try to delete any v. rules in the first paragraph of the second frame
        var first_line = p_last.lines[-1].parentTextFrames[0].lines[0];
        delete_rule (first_line.paragraphs[0], os);
        // Now add a rule at the first line of the next frame and extend it to the last line of the last selected paragraph
        rule_length = p_last.lines[-1].baseline - first_line.baseline + ascender + descender + decalage;
        vr = first_line.words[4].insertionPoints[-1].graphicLines.add ();
        vr.appliedObjectStyle = os;
		vr.locked=false; // débloque l'ojet pour le repositionner
        vr.geometricBounds = [0, 0, rule_length, largeur];
		vr.locked=true; // débloque l'ojet pour le repositionner
        }
	vr.locked=true; // rebloque l'ojet pour le empécher le redimensionnement
     avant_apres(valeur_espace);  //ajoute l'espace avant-après le paragraphe.
	}

function vrule_style (s)
    {
	 
		return app.documents[0].objectStyles.item (s)
    }
//
function nettoyer() 
{
    var vr, rule_length;
    var sel = app.selection[0];
	for(var p=0;p<sel.paragraphs.length;p++)
		delete_rule (sel.paragraphs[p]);
}


function delete_rule (p, os)
    {
        avant_apres(-4)
	// suppression des bords
    var g = p.rectangles;
    for (var i = g.length-1; i > -1; i--) {
		g[i].locked=false;
       	g[i].remove ();
	}
	// suppression des lignes
	var g = p.graphicLines;
    for (var i = g.length-1; i > -1; i--) {
			g[i].locked=false;
        	g[i].remove ();
		}
    }

//
function errorM (m)
	{
	alert (m, "Error", true)
	exit ()
	}
//
function avant_apres(val){
/** Action Recorder measures transforms in Points **/
app.scriptPreferences.measurementUnit = MeasurementUnits.millimeters;

var actions = [

function espace(){
	/** command array */
	var commands = [
function modify_spaceBefore(obj){ 
	obj.spaceBefore += val; 
}
,
function modify_spaceAfter(obj){ 
	obj.spaceAfter += val; 
}
];
	var applyToSelection = [true,true];
	var repeats = 1;
	while(repeats--){
	for(var idx=0; idx < commands.length; idx++){
	    try{var i = void 0; (!applyToSelection[idx])?commands[idx]():(function(command){
	    while((i = (i||0)+1) <= app.selection.length){
	         try{ command(app.selection[i-1]); }catch(err){
	         }
	    }})(commands[idx]);}catch(err){
	}}}
}
];

for(var idx = 0; idx < actions.length; idx++){
         actions[idx]()                       
}    
}

